## asis 2014

=== Makefile ===

include Makefile.stub

.PHONY: all
all: asistant

BLD=prod
tools = gnatstub gnatelim gnatmetric gnatpp gnatcheck gnattest

I_DOC   = $(prefix)/share/doc/asis
I_GPS   = $(prefix)/share/gps/plug-ins
G_DOC   = $(prefix)/share/doc/gnat

.PHONY: install
install: install-lib install-asistant

.PHONY: install-asis-doc
install-asis-doc:
	$(MKDIR) $(I_GPS)
	$(MKDIR) $(I_DOC)/html
	$(MKDIR) $(I_DOC)/info
	$(MKDIR) $(I_DOC)/pdf
	$(INSTALL_FILES) documentation/gps_index.xml $(I_GPS)/asis.xml
	-$(INSTALL_FILES) documentation/asis_*.html $(I_DOC)/html/
	-$(INSTALL_FILES) documentation/asis_*.pdf  $(I_DOC)/pdf/
	-$(INSTALL_FILES) documentation/asis_*.info $(I_DOC)/info/

lib/libasis$(arext):
	$(GNATMAKE) -Pasis -XBLD=$(BLD) -XOPSYS=$(OPSYS)

.PHONY: install-tools
install-tools: install-gnat2xml $(tools:%=install-%)
	echo $<

.PHONY: install-gnat2xml
install-gnat2xml: gnat2xml

.PHONY: gnat2xml
gnat2xml:
	cd tools/gnat2xml ; $(MAKE) all

gnat%:
	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)" -p

.PHONY: tools
tools: gnat2xml $(tools)

.PHONY: asistant
asistant: lib/libasis$(arext)
	$(GNATMAKE) "-Ptools/$@/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

.PHONY: gnattest_hash_testing
gnattest_hash_testing:
	$(GNATMAKE) "-Pinternal/tools/gnattest/hash_testing/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

install-gnat%: gnat%
	gprinstall -p -f --prefix=$(prefix) --mode=usage \
		--project-subdir=lib/gnat \
		-XBLD=$(BLD) -XOPSYS=$(OPSYS) tools/gnat$*/gnat$*.gpr

.PHONY: install-gnatcheck-doc
install-gnatcheck-doc:
	$(MKDIR) $(G_DOC)/html
	$(MKDIR) $(G_DOC)/info
	$(MKDIR) $(G_DOC)/pdf
	$(MKDIR) $(G_DOC)/txt
	$(INSTALL_FILES) documentation/gnatcheck_rm.pdf  $(G_DOC)/pdf/
	$(INSTALL_FILES) documentation/gnatcheck_rm*.html $(G_DOC)/html/
	$(INSTALL_FILES) documentation/gnatcheck_rm.info $(G_DOC)/info/
	$(INSTALL_FILES) documentation/gnatcheck_rm.txt $(G_DOC)/txt/

.PHONY: install-lib
install-lib: install-asis-doc
	gprinstall -p -f --prefix=$(prefix) --sources-subdir=include/asis \
		--lib-subdir=lib/asis --project-subdir=lib/gnat \
		-XBLD=$(BLD) -XOPSYS=$(OPSYS) asis.gpr

.PHONY: install-asistant
install-asistant:
	gprinstall -p -f --prefix=$(prefix) --mode=usage \
		--project-subdir=lib/gnat \
		-XBLD=$(BLD) -XOPSYS=$(OPSYS) tools/asistant/asistant.gpr

atre:
	gnat make -Ptools/$@/$@

clean-gnat%:
	gnat clean -Ptools/gnat$*/gnat$*

.PHONY: clean
clean: clean-gnat2xml clean-gnatstub clean-gnatelim clean-gnatpp clean-gnatmetric clean-gnatcheck
	gnat clean -Pasis

force:

=== tools/asistant/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pasistant -XBLD=$(BLD)
clean:
	gnat clean -Pasistant

=== tools/gnat2xml/Makefile ===
include ../../Makefile.stub
BLD=prod

default: all

clean:
	gnat clean -Pgnat2xml
	gnat clean -Pxml2gnat

# Make file for building gnat2xml and related tools, and for running tests.

# Targets:
#
#   'all' -- build all the programs and generate the schema.
#
#   'test' -- run tests.
#
#   'update-schema' -- copy the newly generated schemas to the actual schemas.
#    This is for gnat2xml developers to use after making changes that cause
#    changes in the schema output by gnat2xsd (after checking that those
#    changes are correct).

TIME=
#TIME=/usr/bin/time -f '%e seconds = %E'

EXTRA_GNATMAKE_FLAGS=
GNATMAKE=$(TIME) gnatmake -g -k
#GNAT2XML_FLAGS=-v -dc
GNAT2XML_FLAGS=-q
GNATPP=$(TIME) gnatpp --pp-old -rnb -q
# -rnb = "replace no backup"

# Test gnat2xsd by comparing its output against expected results.
# Test gnat2xml by validating its output against the schema using xmllint.
.PHONY: test-gnat2xml
test-gnat2xml: all
	@echo "Doing  test-gnat2xml"
	cd test ; rm -rf actual.compact actual.verbose ; mkdir -p actual.compact actual.verbose
	@#???cd test ; $(GNATMAKE) -gnat2012 -gnatct *.ad[sb]
	@#???cd test ; ../gnat2xml -c --compact $(GNAT2XML_FLAGS) -t -mactual.compact *.ad[sb]
	@#???cd test ; $(GNATMAKE) -gnat2012 *.ad[sb] --GCC="../gnat2xml --compact $(GNAT2XML_FLAGS) -t -mactual.compact"
	cd test ; ../gnat2xml --compact $(GNAT2XML_FLAGS) -mactual.compact *.ad[sb]
	cd test ; ../gnat2xml    $(GNAT2XML_FLAGS) -mactual.verbose *.ad[sb]

	@# We can''t validate against the compact schema, because we currently have
	@# interspersed Ada source in the XML output.
	@# cd test ; xmllint --schema ../ada-schema.compact.xsd.new actual.compact/*.xml --noout
	cd test ; xmllint --schema ../ada-schema.xsd.new actual.verbose/*.xml --noout

	@# Compare schemas to expected versions.
	diff    ada-schema.xsd ada-schema.xsd.new | head -80
	diff    ada-schema.compact.xsd ada-schema.compact.xsd.new | head -80
	diff -q ada-schema.xsd ada-schema.xsd.new
	diff -q ada-schema.compact.xsd ada-schema.compact.xsd.new

XML2GNAT_SRCS=*.ad[sb] mckae/*.ad[sb] ../tool_utils/*.ad[sb]

# Test gnat2xml by running the back-translator xml2gnat. If we translate some
# Ada program to XML and then back to Ada, that second Ada program should
# behave the same as the original (although the text of the two programs will
# typically differ in cosmetic ways). The "Ada program" we use for this test
# is gnat2xml itself. We also test for idempotency here: If we translate
# Ada-->XML--Ada-->XML-->Ada-->XML, the second and third stage versions of the
# XML should be identical.
.PHONY: test-xml2gnat
test-xml2gnat: all
	@echo "Doing  test-xml2gnat"
	rm -rf stage
	mkdir -p stage/1/compact-xml
	mkdir -p stage/1/xml stage/2/xml stage/3/xml

	cp -p $(XML2GNAT_SRCS) stage/1
	chmod -w stage/1/*.ad[sb]
	printenv
	cd stage/1 ; $(TIME) ../../gnat2xml --compact $(GNAT2XML_FLAGS) -mcompact-xml *.ads *.adb

	cd stage/1 ; $(TIME) ../../gnat2xml    $(GNAT2XML_FLAGS) -mxml *.ads *.adb
	cd stage/1 ; xmllint --schema ../../ada-schema.xsd.new xml/*.xml --noout
	cd stage/1 ; $(TIME) ../../xml2gnat -v *.ads *.adb
	chmod -w stage/1/generated_ada/*

	cp -p boot.gpr stage/1/generated_ada
	cd stage/1/generated_ada ; $(GNATMAKE) -P boot.gpr -p -XBLD=debug
	cd stage/1/generated_ada ; ./gnat2xsd > ada-schema.xsd.new
	cd stage/1 ; ./generated_ada/gnat2xml $(GNAT2XML_FLAGS) -mxmlxml *.ads *.adb

	cp -p stage/1/generated_ada/*.ad[sb] stage/2
	cd stage/2 ; $(TIME) ../../gnat2xml    $(GNAT2XML_FLAGS) -mxml *.ads *.adb
	cd stage/2 ; xmllint --schema ../../ada-schema.xsd.new xml/*.xml --noout
	cd stage/2 ; $(TIME) ../../xml2gnat *.ads *.adb
	chmod -w stage/2/generated_ada/*

	cp -p stage/2/generated_ada/*.ad[sb] stage/3
	cd stage/3 ; $(TIME) ../../gnat2xml    $(GNAT2XML_FLAGS) -mxml *.ads *.adb
	cd stage/3 ; $(TIME) ../../xml2gnat *.ads *.adb
	chmod -w stage/3/generated_ada/*

	@# Check that the translated version of gnat2xml behaves the same as the
	@# original:
	diff    stage/1/xml stage/1/xmlxml | head -80
	diff -q stage/1/xml stage/1/xmlxml
	@# Check that the translated version of gnat2xsd behaves the same as the
	@# original:
	diff    ada-schema.xsd.new stage/1/generated_ada/ada-schema.xsd.new | head -80
	diff -q ada-schema.xsd.new stage/1/generated_ada/ada-schema.xsd.new

	@# Check for idempotency:
	cd stage/1 ; 'ls' -1A *.ad[sb] > ada-files.list
	cd stage/1/generated_ada ; cat `cat ../ada-files.list` > ../generated_ada.ada
	cd stage/2 ; 'ls' -1A *.ad[sb] > ada-files.list
	cd stage/2/generated_ada ; cat `cat ../ada-files.list` > ../generated_ada.ada
	diff    stage/1/generated_ada.ada stage/2/generated_ada.ada | head -80
	diff -q stage/1/generated_ada.ada stage/2/generated_ada.ada
	diff    stage/2/xml stage/3/xml | head -80
	diff -q stage/2/xml stage/3/xml

# Compare with old gnatpp output:
.PHONY: compare-gnatpp
compare-gnatpp: test-xml2gnat
	@echo "Doing  compare-gnatpp"
	rm -rf stage/1/pp
	mkdir -p stage/1/pp
	cp -p stage/1/*.ad[sb] stage/1/pp
	chmod +w stage/1/pp/*
	-cd stage/1/pp ; $(GNATPP) *.ad[sb]
	cd stage/1/pp ; cat `cat ../ada-files.list` > ../pp.ada
	-diff --side-by-side --width=161 --expand-tabs stage/1/pp.ada stage/1/generated_ada.ada > stage/1/pp.diff
	-wc stage/1/pp.diff
	@-echo -n "pp diffs: "
	@-grep '^................................................................................ ' stage/1/pp.diff | wc

.PHONY: test-gnat2tokens
test-gnat2tokens: all test-xml2gnat
	@echo "Doing  test-gnat2tokens"
	rm -rf stage/tokens ; mkdir -p stage/tokens
	$(TIME) ./gnat2xml-gnat2tokens stage/1/*.ad[sb] > stage/tokens/tokens.out
	gnatchop -w stage/tokens/tokens.out stage/tokens
	cp -p tokens.gpr stage/tokens
	cd stage/tokens ; $(GNATMAKE) -P tokens.gpr -p -XBLD=debug
	cd stage/tokens ; ./gnat2xsd > ../ada-schema.xsd.new

	@# Check that the translated version of gnat2xsd behaves the same as the
	@# original:
	diff    ada-schema.xsd.new stage/ada-schema.xsd.new | head -80
	diff -q ada-schema.xsd.new stage/ada-schema.xsd.new

XML2GNAT_SRC_LIST := $(notdir $(wildcard $(XML2GNAT_SRCS)))

# Test the output of tree-printing procedures (Put_Ada_Tree and
# Put_Regen_Ada in Ada_Trees.Self_Rep) by running the
# regenerate_ada programs produced by xml2gnat:
DO_REGEN_ADA_LIST := $(addprefix do-regen-ada-,$(XML2GNAT_SRC_LIST))
.PHONY: $(DO_REGEN_ADA_LIST)
$(DO_REGEN_ADA_LIST): do-regen-ada-% : all test-xml2gnat
	$(TIME) ./do-regen-ada.sh $*

# Test the output of tree-printing procedures (Put_Ada_Tree and
# Put_Self_Rep in Ada_Trees.Self_Rep) by running the
# self-replicating programs produced by xml2gnat:
DO_SELF_REP_LIST := $(addprefix do-self-rep-,$(XML2GNAT_SRC_LIST))
.PHONY: $(DO_SELF_REP_LIST)
$(DO_SELF_REP_LIST): do-self-rep-% : all test-xml2gnat
	$(TIME) ./do-self-rep.sh $*

.PHONY: test-gnatutil
test-gnatutil: all
	@echo "Doing  test-gnatutil"
	sh -c "ulimit -a"
	cd gnatutil ; rm -rf generated_ada
	cd gnatutil ; $(TIME) ../gnat2xml $(GNAT2XML_FLAGS) *.ad[sb] -mxml
	cd gnatutil ; $(TIME) ../xml2gnat *.ad[sb]
	cd gnatutil ; diff . generated_ada | head -80
	cd gnatutil ; 'ls' -1A *.ad[sb] > ada-files.list
	cd gnatutil/generated_ada ; cat `cat ../ada-files.list` > ../generated_ada.ada
	-diff --side-by-side --width=161 --expand-tabs gnatutil/gnatutil.ada gnatutil/generated_ada.ada > gnatutil.diff
	@# 161 = 79+79+3 (two lines plus 3-character gutter)
	-wc gnatutil.diff
	-cd gnatutil ; wc `cat ada-files.list ` | tail -1
	-grep '^................................................................................ ' gnatutil.diff | wc
	cp -p gnatutil.gpr gnatutil/generated_ada
	cd gnatutil/generated_ada ; $(GNATMAKE) -f -p -P gnatutil.gpr -XBLD=debug

.PHONY: test-buffers
test-buffers:
	@echo "Doing  test-buffers"
	./ada_trees-buffers-test

# Generate debugging output
.PHONY: debug
debug:
	rm -rf generated_ada
	./gnat2xml basic_decl.ads -mxml
	#???./xml2gnat --debug basic_decl.ads
	#--debug switch causes a crash due to "--&pp off" changes.

.PHONY: test
test: all debug test-buffers test-gnat2xml test-xml2gnat test-gnat2tokens do-self-rep-basic_decl.ads do-regen-ada-basic_decl.ads

.PHONY: all
all: compile1 ada_trees-factory.ads ada_trees-factory.adb compile2

# Compile things that don't depend on the generated factory, including the
# factory-generating program.
.PHONY: compile1
compile1:
	#$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -x -P gnat2xml.gpr -I../../../tools/tool_utils -I../../../../tools/tool_utils -I../../../gnat -I../../../../gnat -p
	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P gnat2xml.gpr -p -XBLD=$(BLD)

	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
	@# and ada-schema.compact.xsd.new is compact.
	./gnat2xsd > ada-schema.xsd.new
	./gnat2xsd --compact > ada-schema.compact.xsd.new

ada_trees-generate_factory: compile1

# Depend on the executable ada_trees-generate_factory; if the structure
# of ASIS elements changes, it will be rebuilt by compile1, which will
# trigger regeneration of the factory.
ada_trees-factory.ads ada_trees-factory.adb: ada_trees-generate_factory
	@# Generate ada_trees-factory.ad[sb]
	rm -rf ada_trees-factory.ads ada_trees-factory.adb xml self_rep generated_ada
	./ada_trees-generate_factory
	#???Following is an attempt to reformat the factory. It doesn't work
	#because gnat2xml compiles the factory, and it can't find "with"ed
	#units. This will have to wait until we've more fully integrated with
	#ASIS.
	#mkdir -p xml
	#$(GNATMAKE) -gnat2012 -gnatct -P xml2gnat.gpr ada_trees-factory.adb
	#./gnat2xml -mxml ada_trees-factory.ads ada_trees-factory.adb
	#./xml2gnat ada_trees-factory.ads ada_trees-factory.adb
	#cd generated_ada ; cp -p ada_trees-factory.ads ada_trees-factory.adb ..

# Compile things that depend on the generated factory.
.PHONY: compile2
compile2: ada_trees-factory.ads ada_trees-factory.adb
	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P xml2gnat.gpr -p -XBLD=$(BLD)

.PHONY: pp
pp:
	rm -rf pp.in pp.out
	mkdir -p pp.in
	cp -p stage/3/*.ad[sb] pp.in
	chmod +w pp.in/*
	cp -pr pp.in pp.out
	-cd pp.out ; $(GNATPP) *.ad[sb]
	-diff pp.in pp.out | wc

.PHONY: update-schema
update-schema:
	rm -f ada-schema.xsd.old
	mv ada-schema.xsd ada-schema.xsd.old
	mv ada-schema.xsd.new ada-schema.xsd
	rm -f ada-schema.compact.xsd.old
	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
	mv ada-schema.compact.xsd.new ada-schema.compact.xsd

################

# Target for debugging this Makefile

.PHONY: debug-makefile
debug-makefile:
	@echo "debug-makefile"
	@echo "  XML2GNAT_SRCS = $(XML2GNAT_SRCS)"
	@echo "  XML2GNAT_SRC_LIST = $(XML2GNAT_SRC_LIST)"
	@echo "  DO_SELF_REP_LIST = $(DO_SELF_REP_LIST)"
	@echo "  LARGE_SRCS = $(LARGE_SRCS)"
	@echo "  FAST_DO_SELF_REP_LIST = $(FAST_DO_SELF_REP_LIST)"
	@echo "  DO_REGEN_ADA_LIST = $(DO_REGEN_ADA_LIST)"
	@echo "debug-makefile done"

################################################################

# Reminder of arcane 'make' conventions:

# In the commands of static pattern rules:
# $@ -- target
# $< -- first prerequisite
# $^ -- all prerequisites
# $* -- stem (the part that matched %)

=== tools/gnatcheck/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatcheck -XBLD=$(BLD)
clean:
	gnat clean -Pgnatcheck

=== tools/gnatelim/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatelim -XBLD=$(BLD)
clean:
	gnat clean -Pgnatelim

=== tools/gnatmetric/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatmetric -XBLD=$(BLD)
clean:
	gnat clean -Pgnatmetric

=== tools/gnatstub/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatstub -XBLD=$(BLD)
clean:
	gnat clean -Pgnatstub

=== debian/changelog ===
asis (2014-4) unstable; urgency=medium

  * debian/patches/report_unexpected_gnat_version.diff: delete; caused
    ASIS to report a "wrong" version of GNAT if Gnatvsn.Gnat_Version_String
    returned a string lacking a "(" in it.
  * debian/patches/weak_version_check.diff: new.  Do not check the version
    string of the compiler embedded in the tree files against
    Gnatvsn.Gnat_Version_String.  Checking only the tree version number
    (Tree_IO.ASIS_Version_Number, in libgnatvsn) is sufficient.
    Closes: #765467.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 21 Oct 2014 01:13:57 +0200

asis (2014-3) unstable; urgency=medium

  * Extra priority: asis-programs depends on gnatcoll, asis-dev on gnatvsn-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 06 Oct 2014 17:44:58 +0200

asis (2014-2) unstable; urgency=medium

  * control: fix typo and version: asis-programs Recommends: libaunit-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 04 Oct 2014 21:02:58 +0200

asis (2014-1) unstable; urgency=medium

  [Nicolas Boulenguez]
  * Repackage without GFDL documentations.
  * copyright: upstream license change from GPL 2 -> 3.
  * Depend on gnatcoll, xmlada and gnatprj to build most executables.
  * Manual pages: update doc references, remove authors (see man-pages(7)).
  * Replace confusing and buggy get-orig-source with detailed README.source.
  * Priority: -dev extra because Depends: libgnatvsn-dev.
  * Avoid a GCC version check (redundant ant triggers #759038.
  * Move -dbg to priority extra to please lintian.
  * Standards-Version: 3.9.6 (no changes).

  [Ludovic Brenta]
  * New upstream release.  Package renamings per Debian Policy for Ada:
    libasis2013{,-dev} -> libasis2014{,-dev}
  * debian/patches/remove_ada_tree_predicate.diff: refresh.
  * debian/rules (gnat2xsd): removed upstream, do not build anymore.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 04 Oct 2014 15:43:25 +0200

asis (2013-1) unstable; urgency=low

  [Nicolas Boulenguez]
  * New upstream version. Relies on gnat-4.9. Gnatsync removed.
    Per policy, 3 package renamings, no Replaces/Conflicts.
    Bug #642980 is closed in gnat-4.8, work-around removed.
    remove_ada_tree_predicate.diff: predicate misused, 4.9 detects it.
  * control: -dev Suggests asis-doc, not libasis-doc.
  * rules: get-orig-source may be called outside the source directory.
    Remove run times assertions and style checking.
    Run-tests target obsoleted by sadt from devscripts.
  * Standards-Version: 3.9.5 (no changes).

  [Ludovic Brenta]
  * Do not build gnatcheck anymore as it requires gnatcoll which is not
    yet packaged.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 May 2014 13:16:59 +0200

=== debian/control ===
Source: asis
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Section: libdevel
Priority: extra
Standards-Version: 3.9.6
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
# The ASIS library by itself only requires gnatvsn.
 gnat, gnat-4.9, libgnatvsn4.9-dev, libgnatprj4.9-dev,
 libgnatcoll1.6-dev,
 libxmlada5-dev,
 dh-ada-library
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
Vcs-Mtn: www.ada-france.org org.debian.asis
Homepage: http://libre.adacore.com/libre/tools
XS-Testsuite: autopkgtest

Package: libasis2014-dev
Replaces: libasis2013-dev
Conflicts: libasis2013-dev
Architecture: any
Depends: ${ada:Depends}, ${misc:Depends}
Suggests: asis-doc, libasis-dbg
Description: Ada Semantic Interface Specification (ASIS) headers and libraries
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package lets you build ASIS applications with GNAT.

Package: asis-programs
Architecture: any
Section: devel
Depends: gnat, gnat-4.9, ${shlibs:Depends}, ${misc:Depends}
Recommends: libaunit3.7.1-dev
Description: Ada Semantic Interface Specification (ASIS) example programs
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
  * asistant is an interactive command-line tool to explore the ASIS parse tree
    of a program.
  * gnatcheck verifies the conformance of source text to coding conventions
  * gnatelim finds out unused subprograms and eliminates them.
  * gnatmetric calculates metrics such as code complexity.
  * gnatpp is a pretty-printer which reformats Ada source text according to
    a default or user-specified style guide.
  * gnatstub generates an empty but compilable body for a given specification.
  * gnattest creates AUnit test skeletons and harness for a project
    (gnattest requires the libaunit development package to be installed)

Package: libasis2014
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-4.9, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) runtime library
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the libraries necessary to execute ASIS programs.

Package: libasis-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: ${ada:Depends}, ${misc:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: Ada Semantic Interface Specification (ASIS) runtime library - debugging symbols
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the symbols necessary to debug ASIS programs using gdb.

Package: asis-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada Semantic Interface Specification (ASIS) documentation
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the tutorial, news and examples, but not the
 extensive manuals until their license has been clarified.

=== debian/rules ===
#! /usr/bin/make -rf
# Debian build script for asis
# Copyright (c) 2003-2014 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2014 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your
# option) any later version. This build script is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY; without even
# the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details. You
# should have received a copy of the GNU General Public License
# distributed with this build script; see file
# /usr/share/common-licenses/GPL. If not, see <http://www.gnu.org/licenses/>.

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk
ADAFLAGS += -gnatfno -gnatwa -gnatVa

soversion := $(shell sed -n -e "s/^Package: libasis\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef soversion
  $(warning Could not guess soversion from debian/control)
endif

BUILDER_OPTIONS := \
  $(subst -j,-XPROCESSORS=,$(BUILDER_OPTIONS)) \
  $(foreach v,ADAFLAGS LDFLAGS soversion,"-X$(v)=$($(v))")

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# Ignore upstream Makefile.
override_dh_auto_configure:
override_dh_auto_build-arch:
override_dh_auto_build-indep:
override_dh_auto_test:
override_dh_auto_install:
override_dh_auto_clean::

######################################################################
# Build dynamic and static versions of the library.
# Import the dynamic version of the library and build each tool.
TOOLS := asistant gnat2xml gnatcheck gnatelim gnatmetric gnatpp gnatstub gnattest

# Gnatmake/clean fails on non existing object directories.
OBJ_DIRS := lib-dynamic obj-dynamic tools/gnat2xml/obj

BUILD_TOOLS := $(addprefix build-,$(TOOLS))
override_dh_auto_build-arch: build-asis $(BUILD_TOOLS)
 # Static ASIS build.
	gnatmake -XLIBRARY_KIND=static -Pasis.gpr $(BUILDER_OPTIONS)
 # Dynamic ASIS build is a separate target so that build-TOOL can be tested efficiently.
build-asis:
	mkdir -p $(OBJ_DIRS)
	gnatmake -XLIBRARY_KIND=dynamic -Pasis.gpr $(BUILDER_OPTIONS)
$(BUILD_TOOLS): build-%: build-asis
	gnatmake -XLIBRARY_KIND=dynamic -Ptools/$*/$*.gpr $(EXECUTABLE) $(BUILDER_OPTIONS)

# For now, restrict gnat2xml.gpr to one executable. See asis-doc.TODO.
build-gnat2xml: EXECUTABLE := gnat2xml-driver.adb

# Restrict gnatcheck to one executable. -docgen seems unusable in this
# archive, it relies on a texinfo source per rule.
build-gnatcheck: EXECUTABLE := gnatcheck-driver.adb

override_dh_auto_clean::
	mkdir -p $(OBJ_DIRS)
	gnatclean -XLIBRARY_KIND=static -Pasis.gpr
  # Parts of tool_utils are compiled because some tools import it.
	for subdir in tool_utils $(TOOLS); do \
	  gnatclean -XLIBRARY_KIND=dynamic -Ptools/$$subdir/$$subdir.gpr; \
	done
  # Gnatclean would not remove the directories nor the .so file.
	rm -fr lib-dynamic obj-dynamic

override_dh_install-arch:
	dh_install --package=asis-programs $(foreach t,$(TOOLS),tools/$(t)/$(t)) usr/bin

## asis 2015

=== Makefile ===

include Makefile.stub

.PHONY: all

BLD=prod
COMPS=lib
# lib/tools/toolsdev

# ==================================================== build

all:
	$(GPRBUILD) -p -j0 -XBLD=$(BLD) -XOPSYS=$(OPSYS) \
		$(GPRBUILD_FLAGS) -XASIS_COMPONENTS=$(COMPS) build_asis.gpr

tools: setup
	$(GPRBUILD) -p -j0 -XBLD=$(BLD) -XOPSYS=$(OPSYS) \
		$(GPRBUILD_FLAGS) -XASIS_COMPONENTS=tools build_asis.gpr

setup:
	$(GPRBUILD) -p  -XBLD=$(BLD) tools/tool_utils/generate_factory.gpr
	rm -rf tools/tool_utils/ada_trees-factory.ads tools/tool_utils/ada_trees-factory.adb
	rm -rf tools/gnat2xml/ada_trees-factory.ads tools/gnat2xml/ada_trees-factory.adb
	cd tools/tool_utils ; ./ada_trees-generate_factory$(exe_ext)


# ==================================================== install

install-clean:
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asislib))
	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
		--project-subdir=lib/gnat asislib
endif

install: install-clean
	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=lib build_asis.gpr

install-tools-clean:
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asistools))
	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
		--project-subdir=lib/gnat asistools
endif

install-tools: install-tools-clean
	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=tools build_asis.gpr

# ==================================================== test

gnattest_hash_testing:
	$(GPRBUILD) "-Pinternal/tools/gnattest/hash_testing/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

# ==================================================== clean

clean:
	-$(GPRCLEAN) -XASIS_COMPONENTS=lib build_asis.gpr
	-$(GPRCLEAN) -XASIS_COMPONENTS=toolsdev build_asis.gpr
	-$(GPRCLEAN) tools/tool_utils/generate_factory.gpr
	rm -f tools/tool_utils/ada_trees-factory.ads tools/tool_utils/ada_trees-factory.adb

=== tools/gnat2xml/Makefile ===
--- 
+++ 
@@ -1,12 +1,3 @@
-include ../../Makefile.stub
-BLD=prod
-
-default: all
-
-clean:
-	gnat clean -Pgnat2xml
-	gnat clean -Pxml2gnat
-
 # Make file for building gnat2xml and related tools, and for running tests.
 
 # Targets:
@@ -20,15 +11,42 @@
 #    changes in the schema output by gnat2xsd (after checking that those
 #    changes are correct).
 
+include ../../Makefile.stub
+BLD=prod
+
 TIME=
 #TIME=/usr/bin/time -f '%e seconds = %E'
 
-EXTRA_GNATMAKE_FLAGS=
-GNATMAKE=$(TIME) gnatmake -g -k
-#GNAT2XML_FLAGS=-v -dc
+GPRBUILD=$(TIME) gprbuild -g
 GNAT2XML_FLAGS=-q
 GNATPP=$(TIME) gnatpp --pp-old -rnb -q
-# -rnb = "replace no backup"
+
+# ==================================================== build
+
+default: all
+
+all:
+	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
+	@# and ada-schema.compact.xsd.new is compact.
+	./gnat2xsd > ada-schema.xsd.new
+	./gnat2xsd --compact > ada-schema.compact.xsd.new
+
+.PHONY: update-schema
+update-schema:
+	rm -f ada-schema.xsd.old
+	mv ada-schema.xsd ada-schema.xsd.old
+	mv ada-schema.xsd.new ada-schema.xsd
+	rm -f ada-schema.compact.xsd.old
+	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
+	mv ada-schema.compact.xsd.new ada-schema.compact.xsd
+
+# ==================================================== clean
+
+clean:
+	rm -rf obj stage  ada-schema.*new
+
+# ==================================================== test
+
 
 # Test gnat2xsd by comparing its output against expected results.
 # Test gnat2xml by validating its output against the schema using xmllint.
@@ -36,9 +54,6 @@
 test-gnat2xml: all
 	@echo "Doing  test-gnat2xml"
 	cd test ; rm -rf actual.compact actual.verbose ; mkdir -p actual.compact actual.verbose
-	@#???cd test ; $(GNATMAKE) -gnat2012 -gnatct *.ad[sb]
-	@#???cd test ; ../gnat2xml -c --compact $(GNAT2XML_FLAGS) -t -mactual.compact *.ad[sb]
-	@#???cd test ; $(GNATMAKE) -gnat2012 *.ad[sb] --GCC="../gnat2xml --compact $(GNAT2XML_FLAGS) -t -mactual.compact"
 	cd test ; ../gnat2xml --compact $(GNAT2XML_FLAGS) -mactual.compact *.ad[sb]
 	cd test ; ../gnat2xml    $(GNAT2XML_FLAGS) -mactual.verbose *.ad[sb]
 
@@ -80,7 +95,7 @@
 	chmod -w stage/1/generated_ada/*
 
 	cp -p boot.gpr stage/1/generated_ada
-	cd stage/1/generated_ada ; $(GNATMAKE) -P boot.gpr -p -XBLD=debug
+	cd stage/1/generated_ada ; $(GPRBUILD) -P boot.gpr -p -XBLD=debug
 	cd stage/1/generated_ada ; ./gnat2xsd > ada-schema.xsd.new
 	cd stage/1 ; ./generated_ada/gnat2xml $(GNAT2XML_FLAGS) -mxmlxml *.ads *.adb
 
@@ -136,7 +151,7 @@
 	$(TIME) ./gnat2xml-gnat2tokens stage/1/*.ad[sb] > stage/tokens/tokens.out
 	gnatchop -w stage/tokens/tokens.out stage/tokens
 	cp -p tokens.gpr stage/tokens
-	cd stage/tokens ; $(GNATMAKE) -P tokens.gpr -p -XBLD=debug
+	cd stage/tokens ; $(GPRBUILD) -P tokens.gpr -p -XBLD=debug
 	cd stage/tokens ; ./gnat2xsd > ../ada-schema.xsd.new
 
 	@# Check that the translated version of gnat2xsd behaves the same as the
@@ -178,7 +193,7 @@
 	-cd gnatutil ; wc `cat ada-files.list ` | tail -1
 	-grep '^................................................................................ ' gnatutil.diff | wc
 	cp -p gnatutil.gpr gnatutil/generated_ada
-	cd gnatutil/generated_ada ; $(GNATMAKE) -f -p -P gnatutil.gpr -XBLD=debug
+	cd gnatutil/generated_ada ; $(GPRBUILD) -f -p -P gnatutil.gpr -XBLD=debug
 
 .PHONY: test-buffers
 test-buffers:
@@ -195,64 +210,6 @@
 
 .PHONY: test
 test: all debug test-buffers test-gnat2xml test-xml2gnat test-gnat2tokens do-self-rep-basic_decl.ads do-regen-ada-basic_decl.ads
-
-.PHONY: all
-all: compile1 ada_trees-factory.ads ada_trees-factory.adb compile2
-
-# Compile things that don't depend on the generated factory, including the
-# factory-generating program.
-.PHONY: compile1
-compile1:
-	#$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -x -P gnat2xml.gpr -I../../../tools/tool_utils -I../../../../tools/tool_utils -I../../../gnat -I../../../../gnat -p
-	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P gnat2xml.gpr -p -XBLD=$(BLD)
-
-	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
-	@# and ada-schema.compact.xsd.new is compact.
-	./gnat2xsd > ada-schema.xsd.new
-	./gnat2xsd --compact > ada-schema.compact.xsd.new
-
-ada_trees-generate_factory: compile1
-
-# Depend on the executable ada_trees-generate_factory; if the structure
-# of ASIS elements changes, it will be rebuilt by compile1, which will
-# trigger regeneration of the factory.
-ada_trees-factory.ads ada_trees-factory.adb: ada_trees-generate_factory
-	@# Generate ada_trees-factory.ad[sb]
-	rm -rf ada_trees-factory.ads ada_trees-factory.adb xml self_rep generated_ada
-	./ada_trees-generate_factory
-	#???Following is an attempt to reformat the factory. It doesn't work
-	#because gnat2xml compiles the factory, and it can't find "with"ed
-	#units. This will have to wait until we've more fully integrated with
-	#ASIS.
-	#mkdir -p xml
-	#$(GNATMAKE) -gnat2012 -gnatct -P xml2gnat.gpr ada_trees-factory.adb
-	#./gnat2xml -mxml ada_trees-factory.ads ada_trees-factory.adb
-	#./xml2gnat ada_trees-factory.ads ada_trees-factory.adb
-	#cd generated_ada ; cp -p ada_trees-factory.ads ada_trees-factory.adb ..
-
-# Compile things that depend on the generated factory.
-.PHONY: compile2
-compile2: ada_trees-factory.ads ada_trees-factory.adb
-	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P xml2gnat.gpr -p -XBLD=$(BLD)
-
-.PHONY: pp
-pp:
-	rm -rf pp.in pp.out
-	mkdir -p pp.in
-	cp -p stage/3/*.ad[sb] pp.in
-	chmod +w pp.in/*
-	cp -pr pp.in pp.out
-	-cd pp.out ; $(GNATPP) *.ad[sb]
-	-diff pp.in pp.out | wc
-
-.PHONY: update-schema
-update-schema:
-	rm -f ada-schema.xsd.old
-	mv ada-schema.xsd ada-schema.xsd.old
-	mv ada-schema.xsd.new ada-schema.xsd
-	rm -f ada-schema.compact.xsd.old
-	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
-	mv ada-schema.compact.xsd.new ada-schema.compact.xsd
 
 ################

=== debian/changelog ===
asis (2015-1) unstable; urgency=medium

  * New upstream version, built with gnat-6.
    Rename -lib and -dev packages because of Ada policy.
  * Drop obsolete dependency on libgnatprj.
  * Disable tools with incomplete sources (removing dependency on XMLAda).
    gcc-6.diff: adapt ASIS-GPL-2015 to GCC-6 instead of GNAT-GPL-2015.
  * Switch to gprbuild as gnatmake does not support projects anymore.
  * Switch from manual -dbg packages to automatic -dbgsym packages.
  * Enable all hardening flags.
  * Ensure deterministic timestamps in ALI files.
  * watch, README.source: use Adacore redirector.
  * Standards-Version: 3.9.8 (no changes), drop generated XS-Testsuite.
  * Raise priority to optional to follow ftp-master overrides.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 30 Apr 2016 16:41:45 +0200

=== debian/control ===
Source: asis
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Section: libdevel
Priority: extra
Standards-Version: 3.9.8
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-6,
 libgnatvsn6-dev,
# gprbuild handling gnat-6
 gprbuild (>= 2015-2),
# Some tools require gnatcoll.
 libgnatcoll1.7-dev,
# Disabled as long as tools/gnat2xml/gnat2xml.gpr is not used.
# libxmlada-input-sources6-dev,
# libxmlada-sax6-dev,
# libxmlada-dom6-dev,
# dh-ada-library knowing that -dbg packages are obsolete.
 dh-ada-library (>= 6.7)
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
Vcs-Mtn: www.ada-france.org org.debian.asis
Homepage: http://libre.adacore.com/libre/tools

Package: libasis2015-dev
Architecture: any
Depends: ${ada:Depends}, ${misc:Depends}
Suggests: asis-doc
Description: Ada Semantic Interface Specification (ASIS) headers and libraries
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package lets you build ASIS applications with GNAT.

Package: asis-programs
Architecture: any
Section: devel
Priority: optional
Depends: gnat, gnat-6, ${shlibs:Depends}, ${misc:Depends}
Recommends: libaunit3.7.2-dev
Description: Ada Semantic Interface Specification (ASIS) example programs
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
  * asistant is an interactive command-line tool to explore the ASIS parse tree
    of a program.
  * gnatcheck verifies the conformance of source text to coding conventions
  * gnatelim finds out unused subprograms and eliminates them.
  * gnatmetric calculates metrics such as code complexity.
  * gnatpp is a pretty-printer which reformats Ada source text according to
    a default or user-specified style guide.
  * gnatstub generates an empty but compilable body for a given specification.
  * gnattest creates AUnit test skeletons and harness for a project
    (gnattest requires the libaunit development package to be installed)

Package: libasis2015
Architecture: any
Section: libs
Priority: optional
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-6, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) runtime library
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the libraries necessary to execute ASIS programs.

Package: asis-doc
Architecture: all
Section: doc
Priority: optional
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada Semantic Interface Specification (ASIS) documentation
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the tutorial, news and examples, but not the
 extensive manuals until their license has been clarified.

=== debian/rules ===
#! /usr/bin/make -rf
# Debian build script for asis
# Copyright (c) 2003-2014 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2016 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your
# option) any later version. This build script is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY; without even
# the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details. You
# should have received a copy of the GNU General Public License
# distributed with this build script; see file
# /usr/share/common-licenses/GPL. If not, see <http://www.gnu.org/licenses/>.

DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
# PIE should only affect the tools.
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging*.mk

DEB_DATE := $(shell dpkg-parsechangelog -S date)

ADAFLAGS += -gnatfno -gnatwa -gnatVa

soversion := $(shell sed -n -e "s/^Package: libasis\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef soversion
  $(warning Could not guess soversion from debian/control)
endif

BUILDER_OPTIONS := $(subst -j,-XPROCESSORS=,$(BUILDER_OPTIONS))

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)

######################################################################
# Build dynamic and static versions of the library.
# Import the dynamic version of the library and build each tool.
ALL_TOOLS := \
  asistant gnat2xml gnatcheck gnatelim gnatmetric gnatpp gnatstub gnattest
# Only this selection will be built and installed.
# gnat2xml, gnatmetric and gnatppp miss asis_ul-driver.ads.
# gnattest misses gnattest-aggregator.ads
TOOLS := asistant gnatcheck gnatelim gnatstub

override_dh_auto_build-arch: build-asis-dynamic \
                             build-asis-static \
                             $(addprefix build-,$(TOOLS))

.PHONY: build-asis-dynamic build-asis-static
build-asis-dynamic build-asis-static: build-asis-%: | lib-% obj-%
	gprbuild -XLIBRARY_KIND=$* asis.gpr $(BUILDER_OPTIONS) \
	  $(foreach v,ADAFLAGS LDFLAGS soversion,"-X$(v)=$($(v))")
lib-dynamic lib-static obj-dynamic obj-static:
	mkdir $@
override_dh_auto_clean::
	rm -fr lib-dynamic lib-static obj-dynamic obj-static

BUILD_TOOLS := $(addprefix build-,$(ALL_TOOLS))
.PHONY: $(BUILD_TOOLS)
$(BUILD_TOOLS): ADAFLAGS += -fPIE
$(BUILD_TOOLS): LDFLAGS += -fPIE
$(BUILD_TOOLS): build-%: build-asis-dynamic
	gprbuild -XLIBRARY_KIND=dynamic tools/$*/$*.gpr $(EXECUTABLE) $(BUILDER_OPTIONS) \
	  $(foreach v,ADAFLAGS LDFLAGS soversion,"-X$(v)=$($(v))")
override_dh_auto_clean::
	rm -f $(foreach tool,$(ALL_TOOLS),$(addprefix tools/$(tool)/, \
	  *.ali *.o $(tool) auto.cgpr $(tool)-driver.bexch b__$(tool)-driver.ad[bs]))
	rm -f tools/tool_utils/*.ali tools/tool_utils/*.o

# Ensure deterministic timestamps in ALI files even for patched sources.
TOUCHED_TOO_MUCH := \
 asis/a4g-a_opt.ads \
 asis/a4g-gnat_int.adb \
 asis/a4g-ee_cache.adb \
 asis/a4g-contt.adb \
 asis/a4g-mapping.adb
build-asis-dynamic: deterministic-timestamps-in-ali-files-stamp
deterministic-timestamps-in-ali-files-stamp:
	touch --date='$(DEB_DATE)' $(TOUCHED_TOO_MUCH)
	touch $@

# For now, restrict gnat2xml.gpr to one executable. See asis-doc.TODO.
build-gnat2xml: EXECUTABLE := gnat2xml-driver.adb
# gnat2xml has its own object directory.
build-gnat2xml: | tools/gnat2xml/obj
tools/gnat2xml/obj:
	mkdir -p $@
override_dh_auto_clean::
	rm -fr tools/gnat2xml/obj

# Restrict gnatcheck to one executable. -docgen seems unusable in this
# archive, it relies on a texinfo source per rule.
build-gnatcheck: EXECUTABLE := gnatcheck-driver.adb

######################################################################
.PHONY: override_dh_install
override_dh_install:
	dh_install --package=asis-programs $(foreach t,$(TOOLS),tools/$(t)/$(t)) usr/bin
	dh_install --remaining-packages

.PHONY: override_dh_installman
override_dh_installman:
	dh_installman --package=asis-programs $(foreach t,$(TOOLS),debian/man/$(t).1)
	dh_installman --remaining-packages

=== debian/watch ===
version=3
opts=filenamemangle=s/^.*download=//,dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/asis \
.*asis-gpl-(\d{4})-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
